import{s as Pe,f as Ae,n as Fe,o as Ee}from"../chunks/scheduler.37c15a92.js";import{S as Re,i as Ue,g as r,s as a,r as ie,A as Ie,h as l,f as n,c as s,j as ke,u as ae,x as o,k as se,y as qe,a as i,v as re,d as le,t as oe,w as me}from"../chunks/index.7cb9c9b8.js";import{H as ue,E as Se}from"../chunks/EditOnGithub.858acfec.js";function Ge(ge){let m,E,A,R,u,U,g,I,f,fe="In the first unit, we learned to train agents in a single-agent system. When our agent was alone in its environment: <strong>it was not cooperating or collaborating with other agents</strong>.",q,p,pe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/patchwork.jpg" alt="Patchwork"/> <figcaption>A patchwork of all the environments you&#39;ve trained your agents on since the beginning of the course</figcaption>',S,c,ce="When we do multi-agents reinforcement learning (MARL), we are in a situation where we have multiple agents <strong>that share and interact in a common environment</strong>.",G,h,he="For instance, you can think of a warehouse where <strong>multiple robots need to navigate to load and unload packages</strong>.",j,v,ve='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/warehouse.jpg" alt="Warehouse"/> <figcaption>[Image by upklyak](https://www.freepik.com/free-vector/robots-warehouse-interior-automated-machines_32117680.htm#query=warehouse robot&amp;position=17&amp;from_view=keyword) on Freepik</figcaption>',z,d,de="Or a road with <strong>several autonomous vehicles</strong>.",W,w,we='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/selfdrivingcar.jpg" alt="Self driving cars"/> <figcaption>[Image by jcomp](https://www.freepik.com/free-vector/autonomous-smart-car-automatic-wireless-sensor-driving-road-around-car-autonomous-smart-car-goes-scans-roads-observe-distance-automatic-braking-system_26413332.htm#query=self driving cars highway&amp;position=34&amp;from_view=search&amp;track=ais) on Freepik</figcaption>',D,T,Te="In these examples, we have <strong>multiple agents interacting in the environment and with the other agents</strong>. This implies defining a multi-agents system. But first, let’s understand the different types of multi-agent environments.",O,y,B,L,ye="Given that, in a multi-agent system, agents interact with other agents, we can have different types of environments:",J,M,Le="<li><em>Cooperative environments</em>: where your agents need <strong>to maximize the common benefits</strong>.</li>",K,_,Me="For instance, in a warehouse, <strong>robots must collaborate to load and unload the packages efficiently (as fast as possible)</strong>.",N,$,_e="<li><em>Competitive/Adversarial environments</em>: in this case, your agent <strong>wants to maximize its benefits by minimizing the opponent’s</strong>.</li>",Q,H,$e="For example, in a game of tennis, <strong>each agent wants to beat the other agent</strong>.",V,x,He,X,b,xe="<li><em>Mixed of both adversarial and cooperative</em>: like in our SoccerTwos environment, two agents are part of a team (blue or purple): they need to cooperate with each other and beat the opponent team.</li>",Y,C,be='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/soccertwos.gif" alt="SoccerTwos"/> <figcaption>This environment was made by the <a href="https://github.com/Unity-Technologies/ml-agents">Unity MLAgents Team</a></figcaption>',Z,k,Ce="So now we might wonder: how can we design these multi-agent systems? Said differently, <strong>how can we train agents in a multi-agent setting</strong> ?",ee,P,te,F,ne;return u=new ue({props:{title:"An introduction to Multi-Agents Reinforcement Learning (MARL)",local:"an-introduction-to-multi-agents-reinforcement-learning-marl",headingTag:"h1"}}),g=new ue({props:{title:"From single agent to multiple agents",local:"from-single-agent-to-multiple-agents",headingTag:"h2"}}),y=new ue({props:{title:"Different types of multi-agent environments",local:"different-types-of-multi-agent-environments",headingTag:"h2"}}),P=new Se({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit7/introduction-to-marl.mdx"}}),{c(){m=r("meta"),E=a(),A=r("p"),R=a(),ie(u.$$.fragment),U=a(),ie(g.$$.fragment),I=a(),f=r("p"),f.innerHTML=fe,q=a(),p=r("figure"),p.innerHTML=pe,S=a(),c=r("p"),c.innerHTML=ce,G=a(),h=r("p"),h.innerHTML=he,j=a(),v=r("figure"),v.innerHTML=ve,z=a(),d=r("p"),d.innerHTML=de,W=a(),w=r("figure"),w.innerHTML=we,D=a(),T=r("p"),T.innerHTML=Te,O=a(),ie(y.$$.fragment),B=a(),L=r("p"),L.textContent=ye,J=a(),M=r("ul"),M.innerHTML=Le,K=a(),_=r("p"),_.innerHTML=Me,N=a(),$=r("ul"),$.innerHTML=_e,Q=a(),H=r("p"),H.innerHTML=$e,V=a(),x=r("img"),X=a(),b=r("ul"),b.innerHTML=xe,Y=a(),C=r("figure"),C.innerHTML=be,Z=a(),k=r("p"),k.innerHTML=Ce,ee=a(),ie(P.$$.fragment),te=a(),F=r("p"),this.h()},l(e){const t=Ie("svelte-u9bgzb",document.head);m=l(t,"META",{name:!0,content:!0}),t.forEach(n),E=s(e),A=l(e,"P",{}),ke(A).forEach(n),R=s(e),ae(u.$$.fragment,e),U=s(e),ae(g.$$.fragment,e),I=s(e),f=l(e,"P",{"data-svelte-h":!0}),o(f)!=="svelte-g86ko7"&&(f.innerHTML=fe),q=s(e),p=l(e,"FIGURE",{"data-svelte-h":!0}),o(p)!=="svelte-kd78jp"&&(p.innerHTML=pe),S=s(e),c=l(e,"P",{"data-svelte-h":!0}),o(c)!=="svelte-1xcyv7q"&&(c.innerHTML=ce),G=s(e),h=l(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-uacshh"&&(h.innerHTML=he),j=s(e),v=l(e,"FIGURE",{"data-svelte-h":!0}),o(v)!=="svelte-18gvihw"&&(v.innerHTML=ve),z=s(e),d=l(e,"P",{"data-svelte-h":!0}),o(d)!=="svelte-ykw5w2"&&(d.innerHTML=de),W=s(e),w=l(e,"FIGURE",{"data-svelte-h":!0}),o(w)!=="svelte-br0ypy"&&(w.innerHTML=we),D=s(e),T=l(e,"P",{"data-svelte-h":!0}),o(T)!=="svelte-1gsuuqt"&&(T.innerHTML=Te),O=s(e),ae(y.$$.fragment,e),B=s(e),L=l(e,"P",{"data-svelte-h":!0}),o(L)!=="svelte-13iburr"&&(L.textContent=ye),J=s(e),M=l(e,"UL",{"data-svelte-h":!0}),o(M)!=="svelte-fp6vdn"&&(M.innerHTML=Le),K=s(e),_=l(e,"P",{"data-svelte-h":!0}),o(_)!=="svelte-amyg09"&&(_.innerHTML=Me),N=s(e),$=l(e,"UL",{"data-svelte-h":!0}),o($)!=="svelte-i7nze"&&($.innerHTML=_e),Q=s(e),H=l(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-mn21m8"&&(H.innerHTML=$e),V=s(e),x=l(e,"IMG",{src:!0,alt:!0}),X=s(e),b=l(e,"UL",{"data-svelte-h":!0}),o(b)!=="svelte-1qzm0t4"&&(b.innerHTML=xe),Y=s(e),C=l(e,"FIGURE",{"data-svelte-h":!0}),o(C)!=="svelte-1qgya3o"&&(C.innerHTML=be),Z=s(e),k=l(e,"P",{"data-svelte-h":!0}),o(k)!=="svelte-patx3x"&&(k.innerHTML=Ce),ee=s(e),ae(P.$$.fragment,e),te=s(e),F=l(e,"P",{}),ke(F).forEach(n),this.h()},h(){se(m,"name","hf:doc:metadata"),se(m,"content",je),Ae(x.src,He="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/tennis.png")||se(x,"src",He),se(x,"alt","Tennis")},m(e,t){qe(document.head,m),i(e,E,t),i(e,A,t),i(e,R,t),re(u,e,t),i(e,U,t),re(g,e,t),i(e,I,t),i(e,f,t),i(e,q,t),i(e,p,t),i(e,S,t),i(e,c,t),i(e,G,t),i(e,h,t),i(e,j,t),i(e,v,t),i(e,z,t),i(e,d,t),i(e,W,t),i(e,w,t),i(e,D,t),i(e,T,t),i(e,O,t),re(y,e,t),i(e,B,t),i(e,L,t),i(e,J,t),i(e,M,t),i(e,K,t),i(e,_,t),i(e,N,t),i(e,$,t),i(e,Q,t),i(e,H,t),i(e,V,t),i(e,x,t),i(e,X,t),i(e,b,t),i(e,Y,t),i(e,C,t),i(e,Z,t),i(e,k,t),i(e,ee,t),re(P,e,t),i(e,te,t),i(e,F,t),ne=!0},p:Fe,i(e){ne||(le(u.$$.fragment,e),le(g.$$.fragment,e),le(y.$$.fragment,e),le(P.$$.fragment,e),ne=!0)},o(e){oe(u.$$.fragment,e),oe(g.$$.fragment,e),oe(y.$$.fragment,e),oe(P.$$.fragment,e),ne=!1},d(e){e&&(n(E),n(A),n(R),n(U),n(I),n(f),n(q),n(p),n(S),n(c),n(G),n(h),n(j),n(v),n(z),n(d),n(W),n(w),n(D),n(T),n(O),n(B),n(L),n(J),n(M),n(K),n(_),n(N),n($),n(Q),n(H),n(V),n(x),n(X),n(b),n(Y),n(C),n(Z),n(k),n(ee),n(te),n(F)),n(m),me(u,e),me(g,e),me(y,e),me(P,e)}}}const je='{"title":"An introduction to Multi-Agents Reinforcement Learning (MARL)","local":"an-introduction-to-multi-agents-reinforcement-learning-marl","sections":[{"title":"From single agent to multiple agents","local":"from-single-agent-to-multiple-agents","sections":[],"depth":2},{"title":"Different types of multi-agent environments","local":"different-types-of-multi-agent-environments","sections":[],"depth":2}],"depth":1}';function ze(ge){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Be extends Re{constructor(m){super(),Ue(this,m,ze,Ge,Pe,{})}}export{Be as component};
